<?php
/**
* This is a model. It holds the logic.
* It's loaded like this in the controllers: $this->load->model("path/to/model");
* This specific model is: $this->load->model("admin/admin_model")
*
* This model is the logic behind the admin panel. It let's you manage courses, pages etc
*/
class Admin_model extends CI_Model {

	function __construct() {
		$this->load->database();
	}

	function getCourses() {
		$query = $this->db->get('Courses');
		return $query->result();
	}

	function addCourse($cid, $name){
		$data = array(
			'courseID' => $cid ,
			'name' => $name
			);

		$this->db->insert('Courses', $data); 
		mkdir("../courses/".$cid);

	}

	function getExamples($cid) {
		$query = $this->db->get_where('Examples', array("courseID" => $cid));
		return $query->result();
	}

	function addExample($cid, $example, $description){
		$data = array(
			'courseID' => $cid ,
			'exampleName' => $example,
			'description' => $description
			);

		$this->db->insert('Examples', $data); 
		mkdir("../courses/".$cid."/".$example);

	}

	function getPages($cid, $example) {
		$query = $this->db->get_where('Pages', array("courseID" => $cid, "exampleName" => $example));
		return $query->result();
	}

	function addPage($cid, $example, $page){
		$data = array(
			'courseID' => $cid ,
			'exampleName' => $example,
			'pageName' => $page
			);

		$this->db->insert('Pages', $data); 
		mkdir("../courses/".$cid."/".$example."/".$page);

		$data = array(
			'fileName' => $cid."/".$example."/".$page."/documentation",
			'codeLanguage' => $file->lang,
			'fileType' => $file->type,
			'dataBlob' => $output
			);

		$this->db->insert('Files', $data); 

		$data = array(
			'fileName' =>  $cid."/".$example."/".$page."/documentation"  ,
			'pageName' => $page,
			'exampleName' => $example,
			'courseID' => $cid
			);

		$this->db->insert('PageFiles', $data); 

	}

	function updatePage($cid, $example, $page, $documentation, $files){

		$filearr = json_decode($files);

		foreach ($filearr as $file) {
			$output = "";
			$handle = @fopen("../courses/".$cid."/".$example."/".$page."/".$file->filename, "r");
			if ($handle) {

				while (($buffer = fgets($handle, 4096)) !== false) {

					$buffer = str_replace("&", "&amp;", $buffer);
					$buffer = str_replace("<", "&lt;", $buffer);
					$buffer = str_replace(">", "&gt;", $buffer);

					$output .= $buffer;
				}
				if (!feof($handle)) {
					$output .= "Error: unexpected fgets() fail\n";
				}
				fclose($handle);
			}
			
			$data = array(
				'fileName' => $file->filename ,
				'codeLanguage' => $file->lang,
				'fileType' => $file->type,
				'dataBlob' => $output
				);

			$this->db->insert('Files', $data); 

			$data = array(
				'fileName' =>  $file->filename  ,
				'pageName' => $page,
				'exampleName' => $example,
				'courseID' => $cid
				);

			$this->db->insert('PageFiles', $data); 
		}

		$data = array(
			'dataBlob' => $documentation
			);

		$this->db->where("fileName",$cid."/".$example."/".$page."/"."documentation" );
		$this->db->update('Files', $data); 
		

	}

	function uploadFile($files, $cid, $example, $page){
		if(move_uploaded_file($files['tmp_name'], "../courses/".$cid."/".$example."/".$page."/".$files['name'])){
			echo json_encode(array('status'=>'File was uploaded successfuly!'));
		}	
	}
}
